<template>
  <input-base
    :name="name"
    :size="size"
    :error="error"
    v-on:model-focus="focus = true"
    v-on:model-blur="focus = false"
  >
    <div class="input">
      {{
        list.find((e) => e.id == modelValue) == undefined
          ? ""
          : list.find((e) => e.id == modelValue).display_name
      }}
      {{ list.length == 0 ? "Brak elementów" : "" }}
    </div>
    <font-awesome-icon class="icon" :icon="icons.faCaretDown" />
    <div class="dropdown" v-show="focus">
      <input-dynamic-select-item
        v-for="element in list"
        :key="element.id"
        :selected="element.id == modelValue"
        v-on:click.stop="$emit('update:modelValue', element.id)"
      >
        {{ element.display_name }}
      </input-dynamic-select-item>
    </div>
  </input-base>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import InputDynamicSelectItem from "@/components/input/select/InputDynamicSelectItem.vue";
import InputBase from "@/components/input/InputBase.vue";

import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import { faCaretDown } from "@fortawesome/free-solid-svg-icons";

import { InputListItem } from "@/interfaces";

@Options({
  props: {
    modelValue: {
      type: Number,
      requierd: true,
    },
    list: {
      type: Array,
      requierd: true,
    },
    name: {
      type: String,
      requierd: false,
    },
    size: {
      type: String,
      requierd: false,
    },
    error: {
      type: String,
      requierd: false,
    },
  },
  emits: ["update:modelValue"],
  components: {
    FontAwesomeIcon,
    InputDynamicSelectItem,
    InputBase,
  },
})
export default class InputDynamicSelect extends Vue {
  public modelValue!: number;
  public list!: InputListItem[];

  public name?: string;
  public size?: string;
  public error?: string;

  public focus = false;

  public icons = {
    faCaretDown,
  };
}
</script>

<style scoped lang="scss">
@import "@/styles/globals";

.icon {
  padding: $small_spacing;
  padding-left: 0;
}

.input {
  padding: $small_spacing;
  margin: 0;
  display: block;

  border: none;
  outline: none;
  flex-grow: 1;

  font-size: 16px;

  box-sizing: border-box;
}

.dropdown {
  position: absolute;
  width: 100%;
  max-height: 120px;
  top: 42px;
  box-shadow: 0 0 3px 0 $shadow_grey;

  background-color: $white_bg;
  overflow: auto;

  z-index: 3;
}
</style>
